/*
 * Ostatnia aktualizacja:
 * 
 * - $Id: groupchat.c,v 1.1.1.1 2004/11/12 10:47:06 maticompxp Exp $
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <time.h>

#include "libtlen.h"

/*
 * tlen_groupchat_create()
 *
 * Tworzy konferencj
 *
 * - sesja - nasza sesja
 *
 */

int tlen_groupchat_create(struct tlen_session *sesja)
{
    char *query;
    char *malloc_sample = "<presence to=\"@conf\"/><iq to=\"@conf\" type=\"set\" id=\"groupchatregister\"><query xmlns=\"jabber:iq:conference\"><nick></nick><secret></secret></query></iq>";
    int second = tlen_get_second();

    if (!(query = (char *) malloc (strlen(malloc_sample) + strlen(sesja->username) + 10 /*sek1*/ + strlen(sesja->username) + 10 /*sek2*/ + strlen(sesja->username) + 10 /*secret*/)))
    {
	perror("malloc");
	sesja->error = TLEN_ERROR_MALLOC;    
    }

    sprintf (query, "<presence to='%s%d@conf'/><iq to='%s%d@conf' type='set' id='groupchatregister'><query xmlns='jabber:iq:conference'><nick>%s</nick><secret>%d</secret></query></iq>", sesja->username, second, sesja->username, second, sesja->username, second /*I mean - secret, but it can be second too :>*/);
    
    tlen_debug("Create conference query sent\n");
    
    tlen_socket_write_string (sesja, query);
    free(query);
    return 1;
}


/* 
 * tlen_get_second()
 *
 * Zwraca sekund danego dnia
 *
 * - brak parametrw
 *
 * Potrzebna przy zapytaniach konferencyjnych
 *
 */

int tlen_get_second()
{
    int sec;
    time_t t;
    struct tm *tm;
    
    t = time(NULL);
    tm = localtime(&t);
    sec = tm->tm_sec + (tm->tm_min*60) + ((tm->tm_hour*60)*60);
    
    return sec;
}    
